export { RestAPI as Schema2tsServerDefinition } from './code/server';
export interface Schema2tsAPI {
    /** Custom template that used to generate code */ template?: string;
    /** If this is true, template will be treated as url/file path */ isTemplateUrl?: boolean;
    /** Schema that used to generate code */ schema: string | object;
    /** If this is true, schema will be treated as url/file path */ isSchemaUrl?: boolean;
    /** Generate only declarations */ declaration?: boolean;
    /** If you only want to change comments on the top, you may need this. */ customFileComment?: string;
    /** Code generator */ generator?: (server: any, template: string, config: any) => string;
}
export default function ({isTemplateUrl, template, schema, customFileComment, generator, ...config}: Schema2tsAPI): Promise<string>;
