"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const specifications_1 = require("./specifications");
const fs_1 = require("fs");
const path_1 = require("path");
const utils_1 = require("./utils");
const rest_client_1 = require("./code/generator/rest-client");
const defaultTemplate = path_1.join(__dirname, '..', 'src', 'default.template.ts');
const defaultTemplateComment = `*  This file is auto-generated on %when%. DO NOT modify this file directly!
*  Generated by:
* 	    schema2ts %version%
* 	    Typescript %typescript-version%
*
*  Schema2ts: https://github.com/Jack-Works/schema2tscode/
*  Syntax Error in this file? Report there https://github.com/Jack-Works/schema2tscode/issues`;
async function default_1(_a) {
    var { isTemplateUrl, template = isTemplateUrl ? defaultTemplate : fs_1.readFileSync(defaultTemplate, 'utf-8'), schema, customFileComment = defaultTemplateComment, generator = rest_client_1.RestClientGenerator } = _a, config = __rest(_a, ["isTemplateUrl", "template", "schema", "customFileComment", "generator"]);
    if (isTemplateUrl) {
        template = await utils_1.requestFile(template);
    }
    if (!schema) {
        throw new ReferenceError('No input file, use --schema [url/file path] to provide one');
    }
    if (config.isSchemaUrl && typeof schema === 'string') {
        schema = utils_1.parseJSONorYAML(await utils_1.requestFile(schema));
    }
    if (typeof schema === 'string') {
        schema = utils_1.parseJSONorYAML(schema);
    }
    // TODO: Prevent security problem caused by this.
    const leadingComments = `/* tslint:disable */
/*--------------------------------------------------------------------------------------------
${customFileComment.replace('%default-template%', defaultTemplateComment)}
*--------------------------------------------------------------------------------------------*/`;
    const internalExpressOfSchema = await specifications_1.default(schema);
    const code = generator(internalExpressOfSchema, template, {
        declarationOnly: config.declaration,
        leadingComments: leadingComments,
    });
    return code;
}
exports.default = default_1;
//# sourceMappingURL=api.js.map