"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable */
const axios_1 = require("axios");
exports._ = {
    lib: axios_1.default.create({ withCredentials: true }),
    removeEmpty(obj) {
        const cloned = Object.assign({}, obj);
        for (const i in cloned) {
            if (cloned[i] === undefined) {
                delete cloned[i];
            }
        }
        return obj;
    },
    getPathParam(url, params) {
        const data = exports._.removeEmpty(params);
        for (const key in data) {
            const obj = data[key];
            url = url.replace(`{${key}}`, obj.toString());
        }
        return url;
    },
    async request(url, method, { query = {}, body = {}, path = {}, headers = {}, bodyType = {}, }) {
        headers = Object.assign({}, headers);
        if (!headers["Content-Type"] && bodyType === "form") {
            headers["Content-Type"] = "application/x-www-form-urlencoded";
        }
        const request = await exports._.lib.request({
            method,
            url: exports._.getPathParam(url, path),
            params: exports._.removeEmpty(query),
            data: exports._.removeEmpty(body),
            headers,
        });
        return {
            data: request.data,
            headers: request.headers,
            request: request.request,
            status: request.status,
            statusText: request.statusText,
        };
    },
};
//# sourceMappingURL=default.template.js.map