import * as ts from 'typescript';
import { DefaultFileSystemHost } from 'ts-simple-ast/dist/fileSystem';
import { Schema } from 'swagger-schema-official';
import * as Types from './code/types';
import { JSDoc } from './code/server';
/**
 * A FileSystemHost provided to typescript compiler
 */
export declare class ReadonlyFileSystemHost extends DefaultFileSystemHost {
    changes: Map<string, string>;
    getPath(filePath: string): string;
    writeFile(filePath: string, fileText: string): Promise<void>;
    writeFileSync(filePath: string, fileText: string): void;
    readFileSync(filePath: string, encoding?: string): string;
    readFile(filePath: string, encoding?: string): Promise<string>;
}
/** Get a valid variable name from url string */
export declare function getValidVarName(name: string): string;
/** Parse JSON or Yaml */
export declare function parseJSONorYAML(text: string): any;
/** Request a file */
export declare function requestFile(url: string): Promise<string>;
/** Create a Typescript Async function Declaration */
export declare function GenerateAsyncFunction(name: string | ts.Identifier, body: ts.FunctionBody, parameters?: ts.ParameterDeclaration[], returnType?: ts.TypeNode, JSDocCommet?: string, modifiers?: ts.Modifier[]): ts.FunctionDeclaration;
export declare type JSONSchemaPrimitive = 'array' | 'boolean' | 'integer' | 'float' | 'number' | 'null' | 'object' | 'string';
export declare type OpenAPI2AdditionalPrimitive = 'long' | 'double';
/** JSON Schema -> Schema2ts inner express */
export declare function createJSONSchemaToTypes(document: any, nameOptions?: any): Promise<(from: Schema) => Types.Type>;
export declare const getJSONRefName: (x: Schema, openapi?: any) => string | undefined;
export declare function createJSDoc(jsdoc?: JSDoc): string | undefined;
