/* tslint:disable */
/*--------------------------------------------------------------------------------------------

*  This is an example output of schema2ts
*  Original input is: https://raw.githubusercontent.com/OAI/OpenAPI-Specification/master/examples/v2.0/json/petstore.json
*
*  Generated by:
* 	    schema2ts 0.5.0
* 	    Typescript ^2.6.0
*
*  See syntax error in this file?
*       We are working for these features that will break schema2ts, thanks for your waiting
*--------------------------------------------------------------------------------------------*/
/* tslint:disable */
import axios, { AxiosInstance, AxiosPromise } from "axios";
export interface _Response<Status, Data = any, ResponseHeader = any> {
    data: Data;
    status: Status;
    statusText: string;
    headers: ResponseHeader;
    request?: any;
}
export const _ = {
    lib: axios.create({ withCredentials: true }),
    removeEmpty(obj: any) {
        const cloned = { ...obj };
        for (const i in cloned) {
            if (cloned[i] === undefined) {
                delete cloned[i];
            }
        }
        return obj;
    },
    getPathParam(url: string, params: any) {
        const data = _.removeEmpty(params);
        for (const key in data) {
            const obj = data[key];
            url = url.replace(`{${key}}`, obj.toString());
        }
        return url;
    },
    async request(url: string, method: string, { query = {}, body = {}, path = {}, headers = {}, bodyType = {}, }: {
            query?: any;
            body?: any;
            path?: any;
            headers?: any;
            bodyType?: "json" | "form";
        }) {
        headers = { ...headers };
        if (!headers["Content-Type"] && bodyType === "form") {
            headers["Content-Type"] = "application/x-www-form-urlencoded";
        }
        const request = await _.lib.request({
            method,
            url: _.getPathParam(url, path),
            params: _.removeEmpty(query),
            data: _.removeEmpty(body),
            headers,
        });
        return {
            data: request.data,
            headers: request.headers,
            request: request.request,
            status: request.status as any,
            statusText: request.statusText,
        };
    },
};

export var listPets_url = "/pets";
export var listPets_method = "get";
export var createPets_url = "/pets";
export var createPets_method = "post";
export var showPetById_url = "/pets/{petId}";
export var showPetById_method = "get";
export interface listPets_parameter_query {
    /** How many items to return at one time (max 100) */ "limit": number;
}
export interface Pet {
    "id": number;
    "name": string;
    "tag"?: string;
}
export type Pets = Pet[];
export interface listPets_response_header_200 {
    "x-next"?: string;
}
export interface Error {
    "code": number;
    "message": string;
}
/** @summary List all pets */
export function listPets(query: listPets_parameter_query): Promise<_Response<200, Pets, listPets_response_header_200> | _Response<"default", Error>> {
    return _.request(listPets_url, listPets_method, { query: query, bodyType: "json" });
}
/** @summary Create a pet */
export function createPets(): Promise<_Response<"default", Error>> {
    return _.request(createPets_url, createPets_method, { bodyType: "json" });
}
export interface showPetById_parameter_path {
    /** The id of the pet to retrieve */ "petId": string;
}
/** @summary Info for a specific pet */
export function showPetById(path: showPetById_parameter_path): Promise<_Response<200, Pets> | _Response<"default", Error>> {
    return _.request(showPetById_url, showPetById_method, { path: path, bodyType: "json" });
}